﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GridComboSample
{
    public partial class Form1 : Form
    {
        
        public Form1()
        {
            InitializeComponent();
            this.ultraGrid1.InitializeLayout += ultraGrid1_InitializeLayout;
           
                      
            ultraGrid1.MouseUp += ultraGrid1_MouseUp;
            //ultraGrid1.ContextMenuStrip = contextMenuStrip1;
            contextMenuStrip1.Items.Add("Copy");
            contextMenuStrip1.Items.Add("Paste");
           // SetGridContextMenu(ultraGrid1, contextMenuStrip1);
        }
        
        void ultraGrid1_MouseUp(object sender, MouseEventArgs e)
        {
            //when the mouse button is pressed...
            if (sender is UltraGrid)
            {
                if (e.Button == MouseButtons.Right)
                {
                    UltraGrid grid = (UltraGrid)sender;
                    grid.ContextMenuStrip = contextMenuStrip1;


                    if (grid.ContextMenuStrip != null)
                    {
                        // X & Y values are from the MouseDown event
                        Point point = new Point(e.X, e.Y);
                        // The grid context control is a ContexMenuStrip control which worked correctly prior to the MouseDown implementation
                        grid.ContextMenuStrip.Show(grid, point);
                        ultraGrid1.ContextMenuStrip.ItemClicked += ContextMenuStrip_ItemClicked;
                    }
                }
            }
        }
        void ContextMenuStrip_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            switch (e.ClickedItem.Text)
            {
                case "Copy":
                    ultraGrid1.PerformAction(UltraGridAction.Copy);
                    break;
                case "Paste":
                    ultraGrid1.PerformAction(UltraGridAction.Paste);
                    break;
                default:
                    break;
            }
        }
        //public static void SetGridContextMenu(UltraGrid grid, ContextMenuStrip menuStrip, params EventHandler[] events)
        //{
        //    try
        //    {
        //        if (grid == null)
        //            return;

        //        if (grid.ContextMenu == null)
        //            grid.ContextMenu = new ContextMenu();
        //        else
        //            grid.ContextMenu.MenuItems.Clear();

        //        if (menuStrip.Items.Count != events.Length)
        //            // Make sure that there are the same number of event handlers as menu items
        //            return;

        //        // Set the grid context menu from a context menu strip defined on the form
        //        for (int index = 0; index < menuStrip.Items.Count; index++)
        //        {
        //            MenuItem item = new MenuItem(menuStrip.Items[index].Text);
        //            // The tag must be set according to the action type of the menu item "Add", "Del", or "Upd"
        //            item.Tag = menuStrip.Items[index].Tag;
        //            grid.ContextMenu.MenuItems.Add(item);
        //            item.Click += new EventHandler(events[index]);
        //        }
        //    }
        //    catch
        //    {
        //    }
        //}

        #region
        UltraDropDown ultraDropDown1 = new UltraDropDown();
        void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].ValueList = this.ultraDropDown1;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
            this.Controls.Add(ultraDropDown1);
            String[] arrayStore = new String[]{"one", "two", "three"};
            ultraGrid1.DataSource = arrayStore;
            this.BindUltraDropDown(); 
        }

        private void BindUltraDropDown()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("ID", typeof(int));
            dt.Columns.Add("DisplayText", typeof(string));

            dt.Rows.Add(new object[] { 1, "A" });
            dt.Rows.Add(new object[] { 2, "B" });
            dt.Rows.Add(new object[] { 3, "C" });
            dt.AcceptChanges();

            this.ultraDropDown1.SetDataBinding(dt, null);
            this.ultraDropDown1.ValueMember = "ID";
            this.ultraDropDown1.DisplayMember = "DisplayText";
        }
        #endregion

    }
}
